﻿/**
*/
module nemuxi.gui.window.dialog.settingdialog.itemdialog.commanddata;

debug import std.stdio: wl = writefln, pl = printf;
debug(commanddata) void main() {}

//import std.string;
//import win32.windows;

import nemuxi.negui.system.text;
//import nemuxi.base;
import nemuxi.system.language;
//import nemuxi.file.items.item;
//import nemuxi.file.items.itemfunc;
////import nemuxi.image.font;
//import nemuxi.image.unit;
//import nemuxi.gui.window.dialog.selectdialog;
//import nemuxi.gui.control.listbox;
//import nemuxi.gui.control.combobox;
//import nemuxi.negui.control.button.button;
//import nemuxi.negui.control.button.group;
//import nemuxi.negui.control.editbox.editbox;
//import nemuxi.negui.control.label.label;
//import nemuxi.gui.control.iteminput;
//import nemuxi.negui.layout.panel.tansu;
//import nemuxi.negui.layout.panel.line;
//import nemuxi.negui.layout.panel.dual;
//import nemuxi.gui.control.button;
//import nemuxi.negui.control.time.datetimepicker;
//import nemuxi.negui.control.updown.updown;
//import nemuxi.negui.control.toolbar.toolbar;
import nemuxi.negui.window.menu.popup;
//import nemuxi.negui.system.raii;

package:

enum ITEM_COMMAND: COMMAND_ID {
	SEP=0,
	APPLY = 1,
	INIT,
	NEW,
	DEL,

	CHANGE_ID_ADDRRES,
	INIT_ID,

	SELECT_ADDRESS_FILE,
	SELECT_ADDRESS_FOLDER,
	CHANGE_ADDRESSBASE,
	INIT_ADDRESS,
	
	CHANGE_NAME_ADDRESS,
	CHANGE_NAME_ID,
	INIT_NAME,
	
	SELECT_WORKFOLDER_FOLDER,
	CHANGE_WORKFOLDER_ADDRESS,
	INIT_WORKFOLDER,

	INPUT_OPTION,
	INIT_OPTION,

	SELECT_ICON_ICON,
	CHANGE_ICON_ADDRESS,
	INIT_ICON,
	
	INIT_SHOW,
	
	CHANGE_KEY_NAME,
	CHANGE_KEY_ID,
	INIT_KEY,

	INPUT_TAGS,
	EDIT_TAGS,
	CLEAR_TAGS_SELECT,
	CLEAR_TAGS_ALL,
	INIT_TAGS,
	
	INIT_INFORMATION,
	
	CHANGE_REGIST_NOW,
	INIT_REGIST,

	CHANGE_LASTUSE_NOW,
	CHANGE_LASTUSE_REGIST,
	CHANGE_LASTUSE_COUNT,
	INIT_LASTUSE,

	CLEAR_HISTORY_WORKFOLDERS_SELECT,
	CLEAR_HISTORY_WORKFOLDERS_ALL,
	INIT_HISTORY_WORKFOLDERS,
	
	CLEAR_HISTORY_OPTIONS_SELECT,
	CLEAR_HISTORY_OPTIONS_ALL,
	INIT_HISTORY_OPTIONS,
}
struct MENUITEMDATA {
	COMMAND_ID id;
	Text name;
	bool enable=true;

	static:

	ref MENUITEMDATA opCall(COMMAND_ID Id, Text Name) {
		auto data=new MENUITEMDATA;

		data.id   = Id;
		data.name = Name;

		return *data;
	}
	ref MENUITEMDATA SEP() {
		return MENUITEMDATA(ITEM_COMMAND.SEP, Text.emptyText);
	}
}
struct InitMenuData {
	alias MENUITEMDATA MID;
	static:
	
	MENUITEMDATA[] id() {
		return [
			//MID(ITEM_COMMAND.CHANGE_ID_ADDRRES, "アドレスに合わせる"),
			MID(ITEM_COMMAND.CHANGE_ID_ADDRRES, LanguageData.settingItem(LD.SETTING_ITEM.MENU_ADDRESS)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_ID, "初期状態")
			MID(ITEM_COMMAND.INIT_ID,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	
	MENUITEMDATA[] name() {
		return [
			//MID(ITEM_COMMAND.CHANGE_NAME_ADDRESS, "アドレスに合わせる"),
			MID(ITEM_COMMAND.CHANGE_NAME_ADDRESS, LanguageData.settingItem(LD.SETTING_ITEM.MENU_ADDRESS)),
			//MID(ITEM_COMMAND.CHANGE_NAME_ID, "IDに合わせる"),
			MID(ITEM_COMMAND.CHANGE_NAME_ID, LanguageData.settingItem(LD.SETTING_ITEM.MENU_ID)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_NAME, "初期状態")
			MID(ITEM_COMMAND.INIT_NAME,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	
	MENUITEMDATA[] address() {
		return [
			/+
			MID(ITEM_COMMAND.SELECT_ADDRESS_FILE, "ファイル選択"),
			MID(ITEM_COMMAND.SELECT_ADDRESS_FOLDER, "フォルダ選択"),
			+/
			MID(ITEM_COMMAND.SELECT_ADDRESS_FILE, LanguageData.settingItem(LD.SETTING_ITEM.MENU_FILE)),
			MID(ITEM_COMMAND.SELECT_ADDRESS_FOLDER, LanguageData.settingItem(LD.SETTING_ITEM.MENU_FOLDER)),
			MID.SEP,
			//MID(ITEM_COMMAND.CHANGE_ADDRESSBASE, "全てアドレスに合わせる"),
			MID(ITEM_COMMAND.CHANGE_NAME_ADDRESS, LanguageData.settingItem(LD.SETTING_ITEM.MENU_ADDRESS_ALL)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_ADDRESS, "初期状態")
			MID(ITEM_COMMAND.INIT_ADDRESS,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	
	MENUITEMDATA[] wrokFolder() {
		return [
			//MID(ITEM_COMMAND.SELECT_WORKFOLDER_FOLDER, "フォルダ選択"),
			MID(ITEM_COMMAND.SELECT_WORKFOLDER_FOLDER, LanguageData.settingItem(LD.SETTING_ITEM.MENU_FOLDER)),
			MID.SEP,
			//MID(ITEM_COMMAND.CHANGE_WORKFOLDER_ADDRESS, "アドレスに合わせる"),
			MID(ITEM_COMMAND.CHANGE_WORKFOLDER_ADDRESS, LanguageData.settingItem(LD.SETTING_ITEM.MENU_ADDRESS)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_WORKFOLDER, "初期状態")
			MID(ITEM_COMMAND.INIT_WORKFOLDER,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	
	MENUITEMDATA[] option() {
		return [
			//MID(ITEM_COMMAND.INPUT_OPTION, "入力"),
			MID(ITEM_COMMAND.INPUT_OPTION,  LanguageData.message(LD.MESSAGE.INPUT)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_OPTION, "初期状態")
			MID(ITEM_COMMAND.INIT_OPTION,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	
	MENUITEMDATA[] icon() {
		return [
			//MID(ITEM_COMMAND.SELECT_ICON_ICON, "アイコン選択"),
			MID(ITEM_COMMAND.SELECT_ICON_ICON, LanguageData.settingItem(LD.SETTING_ITEM.MENU_ICON)),
			MID.SEP,
			//MID(ITEM_COMMAND.CHANGE_ICON_ADDRESS, "アドレスに合わせる"),
			MID(ITEM_COMMAND.CHANGE_ICON_ADDRESS, LanguageData.settingItem(LD.SETTING_ITEM.MENU_ADDRESS)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_ICON, "初期状態")
			MID(ITEM_COMMAND.INIT_ICON,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	MENUITEMDATA[] show() {
		return [
			//MID(ITEM_COMMAND.INIT_SHOW, "初期状態")
			MID(ITEM_COMMAND.INIT_SHOW,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	MENUITEMDATA[] key() {
		return [
			/+
			MID(ITEM_COMMAND.CHANGE_KEY_NAME, "名前に合わせる"),
			MID(ITEM_COMMAND.CHANGE_KEY_ID, "IDに合わせる"),
			+/
			MID(ITEM_COMMAND.CHANGE_KEY_NAME, LanguageData.settingItem(LD.SETTING_ITEM.MENU_NAME)),
			MID(ITEM_COMMAND.CHANGE_KEY_ID,   LanguageData.settingItem(LD.SETTING_ITEM.MENU_ID)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_KEY, "初期状態")
			MID(ITEM_COMMAND.INIT_KEY,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	MENUITEMDATA[] information() {
		return [
			//MID(ITEM_COMMAND.INIT_INFORMATION, "初期状態")
			MID(ITEM_COMMAND.INIT_INFORMATION,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	MENUITEMDATA[] tags() {
		return [
			/+
			MID(ITEM_COMMAND.INPUT_TAGS, "挿入"),
			MID(ITEM_COMMAND.EDIT_TAGS, "編集"),
			MID(ITEM_COMMAND.CLEAR_TAGS_SELECT, "削除"),
			MID(ITEM_COMMAND.CLEAR_TAGS_ALL, "全部消す"),
			+/
			MID(ITEM_COMMAND.INPUT_TAGS,        LanguageData.message(LD.MESSAGE.INPUT)),
			MID(ITEM_COMMAND.EDIT_TAGS,         LanguageData.message(LD.MESSAGE.EDIT)),
			MID(ITEM_COMMAND.CLEAR_TAGS_SELECT, LanguageData.message(LD.MESSAGE.DELETE)),
			MID(ITEM_COMMAND.CLEAR_TAGS_ALL,    LanguageData.message(LD.MESSAGE.DELETE_ALL)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_TAGS, "初期状態")
			MID(ITEM_COMMAND.INIT_TAGS,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	
	MENUITEMDATA[] regist() {
		return [
			//MID(ITEM_COMMAND.CHANGE_REGIST_NOW, "今"),
			MID(ITEM_COMMAND.CHANGE_REGIST_NOW, LanguageData.settingItem(LD.SETTING_ITEM.HISTORY_NOWDATE)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_REGIST, "初期状態")
			MID(ITEM_COMMAND.INIT_REGIST,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	MENUITEMDATA[] use() {
		return [
			/+
			MID(ITEM_COMMAND.CHANGE_LASTUSE_NOW, "今"),
			MID(ITEM_COMMAND.CHANGE_LASTUSE_REGIST, "登録時"),
			MID(ITEM_COMMAND.CHANGE_LASTUSE_COUNT, "カウント初期化"),
			+/
			MID(ITEM_COMMAND.CHANGE_LASTUSE_NOW, LanguageData.settingItem(LD.SETTING_ITEM.HISTORY_NOWDATE)),
			MID(ITEM_COMMAND.CHANGE_LASTUSE_REGIST, LanguageData.settingItem(LD.SETTING_ITEM.HISTORY_REGIST)),
			MID(ITEM_COMMAND.CHANGE_LASTUSE_COUNT, LanguageData.settingItem(LD.SETTING_ITEM.HISTORY_LAST_COUNT)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_LASTUSE, "初期状態")
			MID(ITEM_COMMAND.INIT_LASTUSE,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	MENUITEMDATA[] historyWorkFolders() {
		return [
			/+
			MID(ITEM_COMMAND.CLEAR_HISTORY_WORKFOLDERS_SELECT, "消す"),
			MID(ITEM_COMMAND.CLEAR_HISTORY_WORKFOLDERS_ALL, "全部消す"),
			+/
			MID(ITEM_COMMAND.CLEAR_HISTORY_WORKFOLDERS_SELECT, LanguageData.message(LD.MESSAGE.DELETE)),
			MID(ITEM_COMMAND.CLEAR_HISTORY_WORKFOLDERS_ALL,    LanguageData.message(LD.MESSAGE.DELETE_ALL)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_HISTORY_WORKFOLDERS, "初期状態")
			MID(ITEM_COMMAND.INIT_HISTORY_WORKFOLDERS,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}
	MENUITEMDATA[] historyOptions() {
		return [
			/+
			MID(ITEM_COMMAND.CLEAR_HISTORY_OPTIONS_SELECT, "消す"),
			MID(ITEM_COMMAND.CLEAR_HISTORY_OPTIONS_ALL, "全部消す"),
			+/
			MID(ITEM_COMMAND.CLEAR_HISTORY_OPTIONS_SELECT, LanguageData.message(LD.MESSAGE.DELETE)),
			MID(ITEM_COMMAND.CLEAR_HISTORY_OPTIONS_ALL,    LanguageData.message(LD.MESSAGE.DELETE_ALL)),
			MID.SEP,
			//MID(ITEM_COMMAND.INIT_HISTORY_OPTIONS, "初期状態")
			MID(ITEM_COMMAND.INIT_HISTORY_OPTIONS,  LanguageData.message(LD.MESSAGE.INITIAL))
		];
	}

	
}


	
